package aspectEditor.aspectEditorUtils;
import java.util.jar.JarFile;
import java.util.*;
import java.io.*;
import edu.neu.ccs.demeter.aplib.*;
import edu.neu.ccs.demeter.*;
class PartGlob extends EdgeGlob {
  protected SourceGlob source;
  public SourceGlob get_source() { return source; }
  public void set_source(SourceGlob new_source) { source = new_source; }
  protected PartNameGlob name;
  public PartNameGlob get_name() { return name; }
  public void set_name(PartNameGlob new_name) { name = new_name; }
  protected TargetGlob target;
  public TargetGlob get_target() { return target; }
  public void set_target(TargetGlob new_target) { target = new_target; }
  public PartGlob() { super(); }
  public PartGlob(SourceGlob source, PartNameGlob name, TargetGlob target) {
    super();
    set_source(source);
    set_name(name);
    set_target(target);
  }
  public static PartGlob parse(java.io.Reader in) throws ParseException { return new Parser(in)._PartGlob(); }
  public static PartGlob parse(java.io.InputStream in) throws ParseException { return new Parser(in)._PartGlob(); }
  public static PartGlob parse(String s) {
    try { return parse(new java.io.StringReader(s)); }
    catch (ParseException e) {
      throw new RuntimeException(e.toString());
    }
  }
  void universal_trv0_bef(UniversalVisitor _v_) {
    super.universal_trv0_bef(_v_);
    ((UniversalVisitor) _v_).before(this);
  }

  void universal_trv0_aft(UniversalVisitor _v_) {
    ((UniversalVisitor) _v_).after(this);
    super.universal_trv0_aft(_v_);
  }

  void universal_trv0(UniversalVisitor _v_) {
    universal_trv0_bef(_v_);
    ((UniversalVisitor) _v_).before_source(this, source);
    source.universal_trv0(_v_);
    ((UniversalVisitor) _v_).after_source(this, source);
    ((UniversalVisitor) _v_).before_name(this, name);
    name.universal_trv0(_v_);
    ((UniversalVisitor) _v_).after_name(this, name);
    ((UniversalVisitor) _v_).before_target(this, target);
    target.universal_trv0(_v_);
    ((UniversalVisitor) _v_).after_target(this, target);
    super.universal_trv0(_v_);
    universal_trv0_aft(_v_);
  }

  void allGlobs_GlobSpec_trv_bef(GlobVisitor v) {
    super.allGlobs_GlobSpec_trv_bef(v);
    ((GlobVisitor) v).before(this);
  }

  void allGlobs_GlobSpec_trv_aft(GlobVisitor v) {
    ((UniversalVisitor) v).after(this);
    super.allGlobs_GlobSpec_trv_aft(v);
  }

  void allGlobs_GlobSpec_trv(GlobVisitor v) {
    allGlobs_GlobSpec_trv_bef(v);
    allGlobs_GlobSpec_trv_aft(v);
  }

  void __trav_matchEdge_GlobSpec_trv_bef(__V_GlobSpec_matchEdge __v0) {
    super.__trav_matchEdge_GlobSpec_trv_bef(__v0);
  }

  void __trav_matchEdge_GlobSpec_trv_aft(__V_GlobSpec_matchEdge __v0) {
    super.__trav_matchEdge_GlobSpec_trv_aft(__v0);
  }

  void __trav_matchEdge_GlobSpec_trv_aro_PartGlob(__V_GlobSpec_matchEdge __v0) {
    source.__trav_matchEdge_GlobSpec_trv(__v0);
    name.__trav_matchEdge_GlobSpec_trv(__v0);
    target.__trav_matchEdge_GlobSpec_trv(__v0);
  }

  static java.lang.reflect.Method __trav_matchEdge_GlobSpec_trv_aro_PartGlob;
  static {
    try {
      __trav_matchEdge_GlobSpec_trv_aro_PartGlob =
        PartGlob.class.getDeclaredMethod("__trav_matchEdge_GlobSpec_trv_aro_PartGlob",
          new Class[] { __V_GlobSpec_matchEdge.class });
    } catch (NoSuchMethodException e) {
      throw new RuntimeException(e.toString());
    }
  }

  void __trav_matchEdge_GlobSpec_trv(__V_GlobSpec_matchEdge __v0) {
    __trav_matchEdge_GlobSpec_trv_bef(__v0);
    ((__V_GlobSpec_matchEdge) __v0).around(new __Subtraversal(__trav_matchEdge_GlobSpec_trv_aro_PartGlob, this, new Object[] { __v0 }), this);
    __trav_matchEdge_GlobSpec_trv_aft(__v0);
  }

  void __trav_collectEdgeGlobs_GlobSpec_trv_bef(__V_GlobSpec_collectEdgeGlobs __v0) {
    super.__trav_collectEdgeGlobs_GlobSpec_trv_bef(__v0);
  }

  void __trav_collectEdgeGlobs_GlobSpec_trv_aft(__V_GlobSpec_collectEdgeGlobs __v0) {
    super.__trav_collectEdgeGlobs_GlobSpec_trv_aft(__v0);
  }

  void __trav_collectEdgeGlobs_GlobSpec_trv(__V_GlobSpec_collectEdgeGlobs __v0) {
    __trav_collectEdgeGlobs_GlobSpec_trv_bef(__v0);
    super.__trav_collectEdgeGlobs_GlobSpec_trv(__v0);
    __trav_collectEdgeGlobs_GlobSpec_trv_aft(__v0);
  }

}
